# Generated by Django 4.2.3 on 2023-09-01 10:08

from django.db import migrations, models
import django.db.models.deletion
import uuid


class Migration(migrations.Migration):
    initial = True

    dependencies = [
        ("contenttypes", "0002_remove_content_type_name"),
        ("auth", "0012_alter_user_first_name_max_length"),
    ]

    operations = [
        migrations.CreateModel(
            name="Transition",
            fields=[
                (
                    "id",
                    models.UUIDField(
                        default=uuid.uuid4,
                        editable=False,
                        primary_key=True,
                        serialize=False,
                        unique=True,
                        verbose_name=uuid.uuid4,
                    ),
                ),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
            ],
            options={
                "verbose_name": "Transition",
                "verbose_name_plural": "Transitions",
            },
        ),
        migrations.CreateModel(
            name="Workflow",
            fields=[
                (
                    "id",
                    models.UUIDField(
                        default=uuid.uuid4,
                        editable=False,
                        primary_key=True,
                        serialize=False,
                        unique=True,
                        verbose_name=uuid.uuid4,
                    ),
                ),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                ("name", models.CharField(max_length=255)),
                ("description", models.TextField(blank=True, null=True)),
                (
                    "workflow_model",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.PROTECT,
                        related_name="workflows",
                        to="contenttypes.contenttype",
                        verbose_name="Workflow Model",
                    ),
                ),
            ],
            options={
                "verbose_name": "Workflow",
                "verbose_name_plural": "Workflows",
            },
        ),
        migrations.CreateModel(
            name="ValidateRuleCondition",
            fields=[
                (
                    "id",
                    models.UUIDField(
                        default=uuid.uuid4,
                        editable=False,
                        primary_key=True,
                        serialize=False,
                        unique=True,
                        verbose_name=uuid.uuid4,
                    ),
                ),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                (
                    "permissions",
                    models.ManyToManyField(
                        blank=True,
                        related_name="validate_rule_condition",
                        to="auth.permission",
                        verbose_name="Permissions",
                    ),
                ),
                (
                    "transition",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="validate_rule_condition",
                        to="cosmic_pipeline.transition",
                        verbose_name="Workflow",
                    ),
                ),
            ],
            options={
                "verbose_name": "Validate Rule Condition",
                "verbose_name_plural": "Validate Rule Conditions",
            },
        ),
        migrations.CreateModel(
            name="TransitionState",
            fields=[
                (
                    "id",
                    models.UUIDField(
                        default=uuid.uuid4,
                        editable=False,
                        primary_key=True,
                        serialize=False,
                        unique=True,
                        verbose_name=uuid.uuid4,
                    ),
                ),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                ("name", models.CharField(max_length=255)),
                ("slug", models.SlugField(blank=True, max_length=255, null=True)),
                ("description", models.TextField(blank=True, null=True)),
                ("initial", models.BooleanField(default=False)),
                (
                    "workflow",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="states",
                        related_query_name="state",
                        to="cosmic_pipeline.workflow",
                    ),
                ),
            ],
            options={
                "verbose_name": "TransitionState",
                "verbose_name_plural": "States",
                "unique_together": {("workflow", "slug")},
            },
        ),
        migrations.AddField(
            model_name="transition",
            name="destination_state",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.PROTECT,
                related_name="transitions_destination",
                to="cosmic_pipeline.transitionstate",
                verbose_name="Destination TransitionState",
            ),
        ),
        migrations.AddField(
            model_name="transition",
            name="source_state",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.PROTECT,
                related_name="transitions_source",
                to="cosmic_pipeline.transitionstate",
                verbose_name="Source TransitionState",
            ),
        ),
        migrations.AddField(
            model_name="transition",
            name="workflow",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.PROTECT,
                related_name="transitions",
                to="cosmic_pipeline.workflow",
                verbose_name="Workflow",
            ),
        ),
        migrations.CreateModel(
            name="RestrictRuleCondition",
            fields=[
                (
                    "id",
                    models.UUIDField(
                        default=uuid.uuid4,
                        editable=False,
                        primary_key=True,
                        serialize=False,
                        unique=True,
                        verbose_name=uuid.uuid4,
                    ),
                ),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                ("name", models.CharField(max_length=255)),
                ("field", models.CharField(max_length=255)),
                (
                    "annotate",
                    models.CharField(
                        blank=True,
                        choices=[
                            ("sum", "Sum"),
                            ("avg", "Average"),
                            ("max", "Maximum"),
                            ("min", "Minimum"),
                            ("count", "Count"),
                        ],
                        max_length=255,
                        null=True,
                    ),
                ),
                (
                    "operator",
                    models.CharField(
                        choices=[
                            ("none", "Equals"),
                            ("exact", "Exact"),
                            ("iexact", "Exact (case-insensitive)"),
                            ("gt", "Greater than"),
                            ("gte", "Greater than or equal to"),
                            ("lt", "Less than"),
                            ("lte", "Less than or equal to"),
                            ("in", "In"),
                            ("isnull", "Is null"),
                        ],
                        max_length=255,
                    ),
                ),
                ("value", models.CharField(max_length=255)),
                (
                    "transition",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="restrict_rule_condition",
                        to="cosmic_pipeline.transition",
                        verbose_name="Transition",
                    ),
                ),
            ],
            options={
                "verbose_name": "Restrict Rule Condition",
                "verbose_name_plural": "Restrict Rule Conditions",
            },
        ),
        migrations.AlterUniqueTogether(
            name="transition",
            unique_together={("workflow", "source_state", "destination_state")},
        ),
    ]
